<template>
    <teleport to="body">
        <transition
            :name="computedAnimation"
            :duration="550"
            appear
        >
            <div
                v-if="pageReady"
                class="modal-backdrop"
                tabindex="-1"
                role="dialog"
                aria-hidden="true"
            >
                <div
                    class="modal"
                    role="dialog"
                    aria-labelledby="modalTitle"
                    aria-describedby="modalDescription"
                    :style="modalStyle"
                    :class="{
                        '!bg-slate-900 !text-white': dark
                    }"
                >
                    <header
                        :ref="header"
                        class="modal-header w-full flex justify-between text-black"
                    >
                        <span
                            class="modal-header-title flex-grow overflow-ellipsis text-ellipsis"
                        >
                            <slot name="title" />
                        </span>
                        <button
                            type="button"
                            class="btn-close text-black"
                            aria-label="Close modal"
                            :class="{
                                'text-black': !dark,
                                'text-white': dark,
                            }"
                            @click="close"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-close"
                            />
                        </button>
                    </header>
                    <section
                        class="modal-body overflow-y-scroll"
                        :style="modalBodyStyle"
                    >
                        <slot name="body" />
                    </section>
                    <footer
                        v-if="hasFooter"
                        :ref="footer"
                        class="modal-footer flex justify-end space-x-2"
                    >
                        <slot name="footer" />
                        <auto-button
                            type="primary"
                            outline
                            :block="false"
                            @click="close"
                        >
                            {{ $t('close') }}
                        </auto-button>
                    </footer>
                </div>
            </div>
        </transition>
    </teleport>
</template>

<script setup>
import {onBeforeUnmount, onMounted, useSlots, computed, ref, nextTick} from "vue";
import EventBus from "!/event-bus.js";
import AutoButton from "~/components/button/auto-button.vue";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";

const props = defineProps({
    hasFooter: {
        required: false,
        type: Boolean,
        default: true,
    },
    listenEscape: {
        required: false,
        type: Boolean,
        default: false,
    },
    dark: {
        required: false,
        type: Boolean,
        default: false,
    }
});
const emit = defineEmits(['close', 'update']);

const $slots = useSlots();
const header = ref();
const footer = ref();
const pageReady = ref(false);

const close = async () => {
    pageReady.value = false;
    await nextTick(() => {
        emit('close');
    });
};

const hasTitle = computed(() => {
    return $slots.title && $slots.title().length;
});

const handleEsc = (evt) => {
    if (evt.key === 'Escape' || evt.keyCode === 27) {
        emit('close');
    }
};
const computedAnimation = computed(() => {
    if (isMobile.value) {
        return 'slide';
    } else {
        return 'slide-fade';
    }
});
const computedScreenWidth = computed(() => {
    return parseInt(window.innerWidth);
});
const computedScreenHeight = computed(() => {
    return parseInt(window.innerHeight);
});
const isMobile = computed(() => {
    return computedScreenWidth.value < 768;
});
const modalWidth = computed(() => {
    if (!isMobile.value) {
        return Math.min(500, (computedScreenWidth.value * 0.9));
    } else {
        return computedScreenWidth.value * 0.9;
    }
});
const modalHeight = computed(() => {
    if (!isMobile.value) {
        return Math.min(800, (computedScreenHeight.value * 0.9));
    } else {
        return computedScreenHeight.value;
    }
});
const modalStyle = computed(() => {
    if (!isMobile.value) {
        return {
            width: `${modalWidth.value}px`,
            'max-height': `${modalHeight.value}px`,
        };
    } else {
        return {
            width: `${modalWidth.value}px`,
            height: `${modalHeight.value}px`,
            position: 'fixed',
            top: 0,
            bottom: 0,
            right: 0,
            'max-height': 'unset',
        };
    }
});
const modalBodyStyle = computed(() => {
    let t = modalHeight.value;
    if (header.value && header.value.innerHeight) {
        t -= header.value.innerHeight;
    }

    if (props.hasFooter && footer.value && footer.value.innerHeight) {
        t -= footer.value.innerHeight;
    }

    if (isMobile.value) {
        return {
            height: `${t}px`,
            'max-height': 'unset',
        };
    } else {
        return {
            'max-height': `${t}px`
        };
    }
});

onMounted(async () => {
    await nextTick(async () => {
        await EventBus.emit('MODAL_OPEN');
    });

    if (props.listenEscape) {
        document.addEventListener('keyup', handleEsc);
    }

    pageReady.value = true;
});

onBeforeUnmount(() => {
    if (props.listenEscape) {
        document.removeEventListener('keyup', handleEsc);
    }

    EventBus.emit('MODAL_CLOSE');
});
</script>

<style scoped>
/*
  Enter and leave animations can use different
  durations and timing functions.
*/
.slide-enter-from .modal,
.slide-leave-to .modal {
    transform: translateX(-100%);
}

.slide-enter-active .modal,
.slide-leave-active .modal {
    transition: 0.55s;
    transform: translate(100%, 0);
}

.slide-enter-to .modal {
    transition: 0.55s;
    transform: translate(0, 0);
}

.slide-fade-enter-active {
    transition: all 0.3s ease-out;
}

.slide-fade-leave-active {
    transition: all 0.8s cubic-bezier(1, 0.5, 0.8, 1);
}

.slide-fade-enter-from,
.slide-fade-leave-to {
    transform: translateX(20px);
    opacity: 0;
}
</style>
